<?php

namespace App\Filament\Exports;

use App\Models\VisitorEntry;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class VisitorEntryExporter extends Exporter
{
    protected static ?string $model = VisitorEntry::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('register_id')
            ->label('REGISTER ID'),
            ExportColumn::make('employeeMaster.name')
            ->label('EMPLOYEE NAME'),
            ExportColumn::make('mobile_number')
            ->label('MOBILE NUMBER'),
            ExportColumn::make('name')
            ->label('VISITOR NAME'),
            ExportColumn::make('company')
            ->label('COMPANY'),
            ExportColumn::make('purpose_of_visit')
            ->label('PURPOSE OF VISIT'),
            ExportColumn::make('type')
            ->label('TYPE'),
            ExportColumn::make('photo')
            ->label('PHOTO')
            ->enabledByDefault(false),
            ExportColumn::make('number_of_person')
            ->label('NUMBER OF PERSON'),
            ExportColumn::make('in_time')
            ->label('IN TIME'),
            ExportColumn::make('out_time')
            ->label('OUT TIME'),
            ExportColumn::make('valid_upto')
            ->label('VALID UPTO'),
            ExportColumn::make('created_at')
            ->label('CREATED AT'),
            ExportColumn::make('updated_at')
            ->label('UPDATED AT'),
            ExportColumn::make('created_by')
            ->label('CREATED BY'),
            ExportColumn::make('updated_by')
            ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
            ->label('DELETED AT'),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your visitor entry export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
